/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#include "GUIUtils.h"
bool GetScreenInfo(display_mode *data)
{
  BScreen *screen = new BScreen();
  if (screen->GetMode(data) == B_OK)
  {
    delete screen;
    return true;
  }
  delete screen;
  return false;
}
BRect CenterOfScreen(int w,int h)
{
  BRect rect;
  display_mode mode;
  if (GetScreenInfo(&mode))
  {
    rect.left   = (mode.virtual_width - w) / 2;
    rect.top    = (mode.virtual_height - h) / 2;
    rect.right  = rect.left + w;
    rect.bottom = rect.top + h;
  }
  else
  {
    rect.left   = 0;
    rect.top    = 0;
    rect.right  = w;
    rect.bottom = h;   
  }
  return rect;
}
BRect ArrangeWindowPosition(int w,int h)
{
  BRect rect;
  display_mode mode;
  static int32 last = -50;

  if (last > 50)
  last = -50;

  if (GetScreenInfo(&mode))
  {
    last += 17;
    rect.left   = ((mode.virtual_width - w) / 2)  + last;
    rect.top    = ((mode.virtual_height - h) / 2) + last;
    rect.right  = rect.left + w;
    rect.bottom = rect.top + h;
  }
  else
  {
    rect.left   = 0;
    rect.top    = 0;
    rect.right  = w;
    rect.bottom = h;   
  }
  return rect;
}
BRect VerifyScreenPosition(BRect rect,int def_width,int def_height)
{
  display_mode mode;
  if (GetScreenInfo(&mode))
  {
    BRect srect = BRect(0,0,mode.virtual_width,mode.virtual_height);
    if (srect.Contains(rect))
    return rect;
          
    // Check the Width()
    if (rect.Width() > srect.Width())
    rect.right = rect.left + srect.Width();
          
    // Check the left
    if (rect.left < 0)
    {
      rect.right = rect.Width();
      rect.left = 0;
    }
    
    // Check the Height()
    if (rect.Height() > srect.Height())
    rect.bottom = rect.top + srect.Height();
          
    // Check the top
    if ((rect.top < 20) || (rect.top > srect.Height()))
    {
      rect.bottom = rect.Height();
      rect.top = 20;
    }
    return rect;
  }
  return BRect(0,0,def_width,def_height);
}
