/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#include "PageOrderView.h"
PageOrderView::PageOrderView(BRect rect,bool collate,bool reverse)
:BView(rect,NULL,B_FOLLOW_NONE,B_WILL_DRAW)
,fcollate(collate),freverse(reverse)
{
  SetViewColor(B_TRANSPARENT_COLOR);
  // load bitmap
  BBitmap *tempbitmap;
  tempbitmap = new BBitmap(BRect(0,0,CollateNReverseBitmapSpace::kDataWidth - 1,CollateNReverseBitmapSpace::kDataHeight - 1),CollateNReverseBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) CollateNReverseBitmapSpace::kDataBits,CollateNReverseBitmapSpace::kDataWidth * CollateNReverseBitmapSpace::kDataHeight,0,CollateNReverseBitmapSpace::kDataColorSpace);
  fbitmap[0] = tempbitmap;

  tempbitmap = new BBitmap(BRect(0,0,CollateReverseBitmapSpace::kDataWidth - 1,CollateReverseBitmapSpace::kDataHeight - 1),CollateReverseBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) CollateReverseBitmapSpace::kDataBits,CollateReverseBitmapSpace::kDataWidth * CollateReverseBitmapSpace::kDataHeight,0,CollateReverseBitmapSpace::kDataColorSpace);
  fbitmap[1] = tempbitmap;

  tempbitmap = new BBitmap(BRect(0,0,NCollateNReverseBitmapSpace::kDataWidth - 1,NCollateNReverseBitmapSpace::kDataHeight - 1),NCollateNReverseBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) NCollateNReverseBitmapSpace::kDataBits,NCollateNReverseBitmapSpace::kDataWidth * NCollateNReverseBitmapSpace::kDataHeight,0,NCollateNReverseBitmapSpace::kDataColorSpace);
  fbitmap[2] = tempbitmap;

  tempbitmap = new BBitmap(BRect(0,0,NCollateReverseBitmapSpace::kDataWidth - 1,NCollateReverseBitmapSpace::kDataHeight - 1),NCollateReverseBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) NCollateReverseBitmapSpace::kDataBits,NCollateReverseBitmapSpace::kDataWidth * NCollateReverseBitmapSpace::kDataHeight,0,NCollateReverseBitmapSpace::kDataColorSpace);
  fbitmap[3] = tempbitmap;

//  Change(collate,reverse);  
}
PageOrderView::~PageOrderView()
{
  for (int i = 0;i < 4;i++)
  delete (BBitmap *) fbitmap[i];
}
void PageOrderView::SetTo(bool collate,bool reverse)
{
  fcollate = collate;
  freverse = reverse;
  Invalidate();
}
void PageOrderView::Draw(BRect updateRect)
{
  if (fcollate)
  {
    if (freverse)
    DrawBitmap(fbitmap[1]);
    else
    DrawBitmap(fbitmap[0]);
  }
  else 
  {
    if (freverse)
    DrawBitmap(fbitmap[3]);
    else
    DrawBitmap(fbitmap[2]);
  }
}