/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#include "PagePrintStyleView.h"
PagePrintStyleView::PagePrintStyleView(BRect rect,bool portrait,bool standard)
:BView(rect,NULL,B_FOLLOW_NONE,B_WILL_DRAW)
,fportrait(portrait),fstandard(standard)
{
  SetViewColor(B_TRANSPARENT_COLOR);
  BBitmap *tempbitmap;

  // Load Portrait standard 
  tempbitmap = new BBitmap(BRect(0,0,PortraitStandardBitmapSpace::kDataWidth - 1,PortraitStandardBitmapSpace::kDataHeight - 1),PortraitStandardBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) PortraitStandardBitmapSpace::kDataBits,PortraitStandardBitmapSpace::kDataWidth * PortraitStandardBitmapSpace::kDataHeight,0,PortraitStandardBitmapSpace::kDataColorSpace);
  fbitmap[0] = tempbitmap;
  // Load Portrait centered
  tempbitmap = new BBitmap(BRect(0,0,PortraitCenteredBitmapSpace::kDataWidth - 1,PortraitCenteredBitmapSpace::kDataHeight - 1),PortraitCenteredBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) PortraitCenteredBitmapSpace::kDataBits,PortraitCenteredBitmapSpace::kDataWidth * PortraitStandardBitmapSpace::kDataHeight,0,PortraitCenteredBitmapSpace::kDataColorSpace);
  fbitmap[1] = tempbitmap;
  // Load Landscape standard
  tempbitmap = new BBitmap(BRect(0,0,LandscapeStandardBitmapSpace::kDataWidth - 1,LandscapeStandardBitmapSpace::kDataHeight - 1),LandscapeStandardBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) LandscapeStandardBitmapSpace::kDataBits,LandscapeStandardBitmapSpace::kDataWidth * PortraitStandardBitmapSpace::kDataHeight,0,LandscapeStandardBitmapSpace::kDataColorSpace);
  fbitmap[2] = tempbitmap;
  // Load Landscape centered
  tempbitmap = new BBitmap(BRect(0,0,LandscapeCenteredBitmapSpace::kDataWidth - 1,LandscapeCenteredBitmapSpace::kDataHeight - 1),LandscapeCenteredBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) LandscapeCenteredBitmapSpace::kDataBits,LandscapeCenteredBitmapSpace::kDataWidth * PortraitStandardBitmapSpace::kDataHeight,0,LandscapeCenteredBitmapSpace::kDataColorSpace);
  fbitmap[3] = tempbitmap;
}
PagePrintStyleView::~PagePrintStyleView()
{
  for (int i = 0; i < 4;i++)
  delete (fbitmap[i]);
}
void PagePrintStyleView::SetTo(bool portrait,bool standard) 
{
  fportrait = portrait;
  fstandard = standard;
  Invalidate();
}
void PagePrintStyleView::Draw(BRect updateRect)
{
  int bitmap_index = 0;
  if (fportrait)
  {
    if (fstandard)
    bitmap_index = 0;
    else
    bitmap_index = 1;
  }
  else
  {
    if (fstandard)
    bitmap_index = 2;
    else
    bitmap_index = 3;
  }  
  BRect bound = Bounds();
  SetHighColor(255,255,255,0);
  FillRect(bound);
  BRect brect = fbitmap[bitmap_index]->Bounds();
  MovePenTo((bound.Width() - brect.Width()) / 2,(bound.Height() - brect.Height()) / 2);
  DrawBitmap(fbitmap[bitmap_index]);
}
