/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#include <PageDefs.h>
float InchToCm(float value)
{
  return value * ConvertSpace::CM_PER_INCH;
}
float CmToInch(float value)
{
  return value / ConvertSpace::CM_PER_INCH;
}
float InchToScreen(float value)
{
  return value * ConvertSpace::ScreenDPI;
}
float CmToScreen(float value)
{
  return CmToInch(value) * ConvertSpace::ScreenDPI;
}
float ScreenToInch(uint32 value)
{
  return (float) ((float) value / (float) ConvertSpace::ScreenDPI);
}
float ScreenToCm(uint32 value)
{
  return InchToCm(value / ConvertSpace::ScreenDPI);
}
BRect GetPaperRect(int funit,int32 paper_type_index,float user_define_width,float user_define_height,bool normal,bool portrait)
{
  BRect rect;
  rect.left = rect.top = 0;
  if (paper_type_index == PAGE_USER_DEFINE)
  {
    int32 width,height;
    if (funit == PRINTER_UNIT_INCH)
    {
      width  = (int32) (user_define_width * 360.0f);
      height = (int32) (user_define_height * 360.0f);
    } 
    else
    {
      width  = (int32) (CmToInch(user_define_width) * 360.0f);
      height = (int32) (CmToInch(user_define_height) * 360.0f);
    }
    rect.right  = width / 5.0f;
    rect.bottom = height / 5.0f;
  }
  else
  {
    rect.right  = g_support_page_info[paper_type_index].max_inch_size.width * 72.0f;
    rect.bottom = g_support_page_info[paper_type_index].max_inch_size.height * 72.0f;
  }
  if (!portrait)
  rect = BRect(rect.top,rect.left,rect.bottom,rect.right);
  // now recalculate the size with resolution params
  return rect;
}
BRect GetPrintRect(int funit,int32 paper_type_index,float user_define_width,float user_define_height,bool normal,bool portrait)
{
  // first get the printable rect into x 360 dpi and y 360 dpi
  BRect rect;
  if (paper_type_index == PAGE_USER_DEFINE)
  {
    int32 width,height;
    if (funit == PRINTER_UNIT_INCH)
    {
      width  = (int32) (user_define_width * 360.0f);
      height = (int32) (user_define_height * 360.0f);
    } 
    else
    {
      width  = (int32) (CmToInch(user_define_width) * 360.0f);
      height = (int32) (CmToInch(user_define_height) * 360.0f);
    }
    rect.left   = 42.0f / 5.0f ;
    rect.right  = (width - 42.0f) / 5.0f;
    if (normal)
    {
      rect.top    = 42.0f / 5.0f;
      rect.bottom = (height - 354) / 5.0f;
    }
    else
    {
      rect.top    = 198.0f / 5.0f;
      rect.bottom = (height - 198) / 5.0f;
    }
  }
  else
  {
    
    rect.left   = g_support_page_info[paper_type_index].printable_area_nornal.left / 5;
    rect.right  = g_support_page_info[paper_type_index].printable_area_nornal.width / 5; 
    
    if (normal)
    {
      rect.top    = g_support_page_info[paper_type_index].printable_area_nornal.top / 5 ;
      rect.bottom = g_support_page_info[paper_type_index].printable_area_nornal.height / 5;
    }
    else
    {
      rect.top    = g_support_page_info[paper_type_index].printable_area_center.top / 5 ;
      rect.bottom = g_support_page_info[paper_type_index].printable_area_center.height / 5;
    }
  }
  // do the orientation swapping 
  if (!portrait)
  rect = BRect(rect.top,rect.left,rect.bottom,rect.right);
  // now recalculate the size with resolution params
  return rect;
}

