/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#ifndef PRINTERINFO_H
#define PRINTERINFO_H
#include <String.h>
#include <Directory.h>
#include <support/TypeConstants.h>
namespace PrinterInfoSpace
{
  const char PrinterNameAttrname[]	= "Printer Name";
  const char PrinterFunctionAddon[]	= "FunctionAddon";
  const char ModelAttrname[]		= "espt:add-on_path";
  const char UnitAttrname[]	 		= "unit_name";
  const char MemoryAttrname[]		= "memory";
};
const uint8 PRINTER_UNIT_INCH = 0;
const uint8 PRINTER_UNIT_CM = 1;
class PrinterInfo
{
  public:
    PrinterInfo();
    ~PrinterInfo();
    
    void PrinterModel(const char *);
    const char *PrinterModel();
    
    void PrinterFunction(const char *);
    const char *PrinterFunction();
    
    void Unit(uint8);
    uint8 Unit();
    
    void Memory(uint32);
    uint32 Memory();
    
    void Read(BNode *printer_file);
    void Write(BNode *printer_file);
    
    const char *PrinterName();
  private:
    BString        	fmodel;
    BString         fprintername;
    uint32  	   	fmemory;
    uint8          	funit;
};
#endif