/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
/* 
history
file version 1.0.1 
*/
#ifndef RASTERSPOOL_H
#define RASTERSPOOL_H
#include <SpoolFile.h>
#include <ScaleInfo.h>
#include <View.h>
namespace RasterSpoolSpace
{
  BRect const EMPTYRECT = BRect(0,0,0,0);
};
class RasterSpool : public ScaleInfo
{
  public:
    RasterSpool();
    ~RasterSpool();
 
    /* ====================================================================== */
    BRect PrintableFrame();			// printable frame (x1,y1,x2,y2); from the paper prospective
    BRect ScaningFrame();			// scanning frame  (x1,y1,x2,y2); from printable prospective
    BRect ScaningRect();			// scanning rect of the scanning frame
    /* ====================================================================== */
  
    /* ====================================================================== */
    bool Init(SpoolFile *,int maxline);		// done
    bool InitOK();						    // return init status
    void Uninit();							// done
    /* ====================================================================== */

    /* ====================================================================== */
    bool SetToPage(int pagenumber);			// done
    bool ScanNext();						// done
    int PageNumber();
    /* ====================================================================== */
    BBitmap *Bitmap();
  private:
    void UnsetValue();				        // done
    
    BRect RotateRect(BRect);				// done
    BRect GetRectBounds(BRect);				// done
    void PreCalculatePostScanFrame();		// done
    void UninitBitmap();					// done	

    void SpecialEffectPortraitRotate180();					// done
    void SpecialEffectPortraitRotate180ToGrayScale();		// done
    void SpecialEffectPortraitToGrayScale();				// done

    void SpecialEffectLandscapeRotate180();					// done		
    void SpecialEffectLandscapeRotate180ToGrayScale();
    void SpecialEffectLandscape();							// done
    void SpecialEffectLandscapeToGrayScale();				// done
    
    void RetrievePixel(BBitmap *bitmap,int x,int y,rgb_color *color_value);			// done
    void WriteGrayPixel(BBitmap *bitmap,int x,int y,rgb_color color_value);			// done
    void WriteColorPixel(BBitmap *bitmap,int x,int y,rgb_color color_value);		// done
    bool RasterSpool::IsWhite(rgb_color color_value);								// done
  private:
    int   fpagenumber;

    BRect fprintableframe;
    BRect fprintablebounds;
    
    BRect fscanframe;
    BRect fpostscanframe;
    BRect fbufferrect;   

    BRect fscreenscale_pagerect;
    BRect fprintscale_pagerect;
    
    SpoolFile *fspoolfile;
    BBitmap   *fbitmap;
    bool  fendofscan;
    bool  finit;
};
#endif