/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#ifndef SCALEINFO_H
#define SCALEINFO_H
#include <Rect.h>
#include <PageDefs.h>
class ScaleInfo
{
  public:
    ScaleInfo();								// done
    ScaleInfo(int64 xres,int64 yres);			// done
    ~ScaleInfo();								// done
    
    void SetTo(int64 xres,int64 yres);			// done
    void Unset();								// done
    
    int64 XResolution()const;					// done
    int64 YResolution()const;					// done
    int64 Resolution()const;					// done

    float DrawScale()const;						// done
  protected:
    BRect NonScaleToDrawScale(BRect);			// done
    
    BRect DrawScaleToNonScale(BRect);			// done

    float DrawScaleXToNonScale(float)const;		// done
    float DrawScaleYToNonScale(float)const;		// done
    
    float NonScaleXToDrawScale (float)const;	// done
    float NonScaleYToDrawScale (float)const;	// done
  private:
    int64 fx_res;
    int64 fy_res;

    int64 fmax_res;

    float fdraw_scale;
};
#endif