/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#include <SpoolFileHeader.h>
SpoolFileHeader::SpoolFileHeader()
:finit(false)
{

}
    
bool SpoolFileHeader::SetTo(BFile *file)
{
  BMessage *msg;
  if (file->InitCheck() != B_OK)
  goto err_0;
  // seek to offset 0x0 (beginning of the file)
  file->Seek(0,SEEK_SET);
  
  // read print_file_header
  if (file->Read(&f_print_header,sizeof(f_print_header)) != sizeof(f_print_header))
  {
    goto err_0;
  }

  // create msg BMessage object
  msg = new BMessage();
  if (msg == NULL)
  {
    goto err_0;
  }
  
  // unflatten msg data from the buffer to the msg
  if (msg->Unflatten(file) != B_OK)
  {
    delete msg;
    goto err_0;
  }
  
  // paper rect
  if (msg->FindRect(MSGSTORE_NAME_PAPER_RECT,&fpaperrect) != B_OK)
  {
    goto retrieve_error;
  }
  // printable rect
  if (msg->FindRect(MSGSTORE_NAME_PRINTABLE_RECT,&fprintrect) != B_OK)
  {
    goto retrieve_error;
  }

  // number of copies
  if (msg->FindInt32(MSGSTORE_NAME_COPIES,&fcopies) != B_OK)
  {
    goto retrieve_error;
  }
  
  // scaling
  if (msg->FindFloat(MSGSTORE_NAME_SCALING,&fscaling) != B_OK)
  {
    goto retrieve_error;
  }
  
  // x resolution
  if (msg->FindInt64(MSGSTORE_NAME_RESOLUTION_X,&fxres) != B_OK)
  {
    goto retrieve_error;
  }
  
  // y resolution
  if (msg->FindInt64(MSGSTORE_NAME_RESOLUTION_Y,&fyres) != B_OK)
  {
    goto retrieve_error;
  }
  
  // media type
  if (msg->FindInt32(MSGSTORE_NAME_QUALITY_PAPER_KIND,&fmedia) != B_OK)
  {
    goto retrieve_error;
  }
  
  // paper feeder
  if (msg->FindInt32(MSGSTORE_NAME_PAPER_FEEDER,&ffeeder) != B_OK)
  {
    goto retrieve_error;
  }

  // collate order
  if (msg->FindBool(MSGSTORE_NAME_COLLATE_ORDER,&fcollate) != B_OK)
  {
    goto retrieve_error;
  }

  // reverse order
  if (msg->FindBool(MSGSTORE_NAME_REVERSE_ORDER,&freverse) != B_OK)
  {
    goto retrieve_error;
  }
  
  // rotate 180
  if (msg->FindBool(MSGSTORE_NAME_ROTATE_180,&frotate) != B_OK)
  {
    goto retrieve_error;
  }

  // color printing
  if (msg->FindBool(MSGSTORE_NAME_PRINTING_COLOR,&fcolor) != B_OK)
  {
    goto retrieve_error;
  }

  // preview
  if (msg->FindBool(MSGSTORE_NAME_PREVIEW,&fpreview) != B_OK)
  {
    goto retrieve_error;
  }

  // first page  
  if (msg->FindInt32(MSGSTORE_NAME_FIRST_PAGE,&ffirstpage) != B_OK)
  {
    goto retrieve_error;
  }

  // last page
  if (msg->FindInt32(MSGSTORE_NAME_LAST_PAGE,&flastpage) != B_OK)
  {
    goto retrieve_error;
  }

  // normal or centered print style
  if (msg->FindBool(MSGSTORE_NAME_PRINTABLE_STYLE,&fnormal) != B_OK)
  {
    goto retrieve_error;
  }

  // orientation
  if (msg->FindInt32(MSGSTORE_NAME_ORIENTATION,&fportrait) != B_OK)
  {
    goto retrieve_error;
  }

  delete msg;
  return finit = true;

  // retrieve error handling
  retrieve_error:
  delete msg;
  return false;

  // error handling
  err_0:
  return false;  
}

bool SpoolFileHeader::InitOK()
{
  return finit;
}
void SpoolFileHeader::Unset()
{
  finit = false;
}    
struct print_file_header SpoolFileHeader::PrintFileHeader()
{
  return f_print_header;
}
    
BRect SpoolFileHeader::PaperRect()
{
  return fpaperrect; 
}

BRect SpoolFileHeader::PrintableRect()
{
  return fprintrect;
}
int32 SpoolFileHeader::CountCopies()
{
  return fcopies;
}
int64 SpoolFileHeader::XResolution()
{
  return fxres;
}
int64 SpoolFileHeader::YResolution()
{
  return fyres;
}
int32 SpoolFileHeader::Media()
{
  return fmedia;
}
int32 SpoolFileHeader::Feeder()
{
  return ffeeder;
}
bool SpoolFileHeader::CollateOrder()
{
  return fcollate;
}
bool SpoolFileHeader::ReverseOrder()
{
  return freverse;
}
bool SpoolFileHeader::Rotate180()
{
  return frotate;
}
bool SpoolFileHeader::ColorPrint()
{
  return fcolor;
}
float SpoolFileHeader::Scaling()
{
  return fscaling;
}
bool SpoolFileHeader::NormalStyle()
{
  return fnormal;
}
bool SpoolFileHeader::CenteredStyle()
{
  return !fnormal;
}
bool SpoolFileHeader::Portrait()
{
  return fportrait == MSGSTORE_ORIENTATION_PORTRAIT;
}
bool SpoolFileHeader::Landscape()
{
  return fportrait != MSGSTORE_ORIENTATION_PORTRAIT;
}
bool SpoolFileHeader::Preview()
{
  return fpreview;
}
int32 SpoolFileHeader::ReversePageNumber(int32 page_num)
{
  return f_print_header.page_count - (page_num - 1);
}
int32 SpoolFileHeader::CountPages()
{
  return f_print_header.page_count;
}

