/* ==================================================== */
/* This source code published as public domain property */ 
/* Developer: Rompo Punyanitya 				   	        */
/*            BCS from RMIT university        	        */
/* Website: www.users.bigpond.net.au/rpunyani/          */
/* Email:   rpunyani@bigpond.net.au                     */
/* ==================================================== */
#ifndef SPOOLFILEHEADER_H
#define SPOOLFILEHEADER_H
#include <unistd.h>
#include <SupportDefs.h>
#include <File.h>
#include <Rect.h>
#include <PrintJob.h>
#include <Message.h>
#include <PageDefs.h>
class SpoolFileHeader
{
  public:
    SpoolFileHeader();
    
    bool SetTo(BFile *spoolfile);
    bool InitOK();
    void Unset();
    
    struct print_file_header PrintFileHeader();
    int32 CountPages();
    
    bool  NormalStyle();
    bool  CenteredStyle();
    bool  Portrait();
    bool  Landscape();
    
    BRect PaperRect();
    BRect PrintableRect();
    int32 CountCopies();
    int64 XResolution();
    int64 YResolution();
    int32 Media();
    int32 Feeder();
    bool CollateOrder();
    bool ReverseOrder();
    bool Rotate180();
    bool ColorPrint();
    float Scaling();
    bool Preview();
  protected:
    int32 ReversePageNumber(int32 page_num);
  private:
    struct print_file_header f_print_header;
    BRect fpaperrect;
    BRect fprintrect;
    int32 fcopies;
    int64 fxres;
    int64 fyres;
    int32 fmedia;
    int32 ffeeder;
    int32 ffirstpage;
    int32 flastpage;
    float fscaling;
    bool  fcollate;
    bool  freverse;
    bool  frotate;
    bool  fcolor;
    bool  fpreview;
    int32  fportrait;
    bool  fnormal;
    bool  finit;
};
#endif